<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"
"http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html;charset=utf-8">
<link rel="stylesheet" href="style_pure.css" type="text/css">
<title>pure_functional.html</title>
</head>
<body>
<div class="why3doc">
<pre><span class="keyword">module</span> <a name="Pure_functional_">Pure_functional</a>

  <span class="keyword">use</span> option.Option, int.<a href="int.html#Int_">Int</a>, list.<a href="list.html#List_">List</a>, list.<a href="list.html#Append_">Append</a>, map.<a href="map.html#Map_">Map</a>

  <span class="keyword">type</span> <a name="value_5">value</a> =
    | <a name="VBool_6">VBool</a> bool
    | <a name="VNat_7">VNat</a> int

  <span class="keyword">type</span> <a name="bin_op_9">bin_op</a> =
    | <a name="PlusOp_10">PlusOp</a>
    | <a name="MinusOp_11">MinusOp</a>
    | <a name="LeOp_12">LeOp</a>
    | <a name="LtOp_13">LtOp</a>
    | <a name="EqOp_14">EqOp</a>

  <span class="keyword">type</span> <a name="expr_16">expr</a> =
    | <a name="EVar_17">EVar</a> string
    | <a name="EVal_18">EVal</a> <a href="#value_5">value</a>
    | <a name="ELet_19">ELet</a> string expr expr
    | <a name="EOp_20">EOp</a> <a href="#bin_op_9">bin_op</a> expr expr
    | <a name="EIf_21">EIf</a> expr expr expr

  <span class="comment">(* `10 + 20 == 30` *)</span>
  <span class="keyword">let</span> <span class="keyword">function</span> <a name="example1_24">example1</a> =
    <a href="#EOp_20">EOp</a> <a href="#EqOp_14">EqOp</a>
    (<a href="#EOp_20">EOp</a> <a href="#PlusOp_10">PlusOp</a> (<a href="#EVal_18">EVal</a> (<a href="#VNat_7">VNat</a> 10)) (<a href="#EVal_18">EVal</a> (<a href="#VNat_7">VNat</a> 20)))
    (<a href="#EVal_18">EVal</a> (<a href="#VNat_7">VNat</a> 30))

  <span class="comment">(* `let x := 10 + 20 in let y := 5 &lt;= x in y` *)</span>
  <span class="keyword">let</span> <span class="keyword">function</span> <a name="example2_30">example2</a> =
    <a href="#ELet_19">ELet</a> &quot;x&quot; (<a href="#EOp_20">EOp</a> <a href="#PlusOp_10">PlusOp</a> (<a href="#EVal_18">EVal</a> (<a href="#VNat_7">VNat</a> 10)) (<a href="#EVal_18">EVal</a> (<a href="#VNat_7">VNat</a> 20)))
    (<a href="#ELet_19">ELet</a> &quot;y&quot; (<a href="#EOp_20">EOp</a> <a href="#LeOp_12">LeOp</a> (<a href="#EVal_18">EVal</a> (<a href="#VNat_7">VNat</a> 5)) (<a href="#EVar_17">EVar</a> &quot;x&quot;))
    (<a href="#EVar_17">EVar</a> &quot;y&quot;))

  <span class="comment">(* `let x := false in x` *)</span>
  <span class="keyword">let</span> <span class="keyword">function</span> <a name="example3_36">example3</a> =
    <a href="#ELet_19">ELet</a> &quot;x&quot; (<a href="#EVal_18">EVal</a> (<a href="#VBool_6">VBool</a> <span class="keyword">false</span>)) (<a href="#EVar_17">EVar</a> &quot;x&quot;)

  <span class="comment">(* `let x := (let y := 1 + 1 in y) in x + x` *)</span>
  <span class="keyword">let</span> <span class="keyword">function</span> <a name="example4_40">example4</a> =
    <a href="#ELet_19">ELet</a> &quot;x&quot; (<a href="#ELet_19">ELet</a> &quot;y&quot; (<a href="#EOp_20">EOp</a> <a href="#PlusOp_10">PlusOp</a> (<a href="#EVal_18">EVal</a> (<a href="#VNat_7">VNat</a> 1)) (<a href="#EVal_18">EVal</a> (<a href="#VNat_7">VNat</a> 1))) (<a href="#EVar_17">EVar</a> &quot;y&quot;))
      (<a href="#EOp_20">EOp</a> <a href="#PlusOp_10">PlusOp</a> (<a href="#EVar_17">EVar</a> &quot;x&quot;) (<a href="#EVar_17">EVar</a> &quot;x&quot;))

  <span class="comment">(* `if 10 &lt;= 12 then 1 else 2` *)</span>
  <span class="keyword">let</span> <span class="keyword">function</span> <a name="example5_45">example5</a> =
    <a href="#EIf_21">EIf</a> (<a href="#EOp_20">EOp</a> <a href="#LeOp_12">LeOp</a> (<a href="#EVal_18">EVal</a> (<a href="#VNat_7">VNat</a> 10)) (<a href="#EVal_18">EVal</a> (<a href="#VNat_7">VNat</a> 12)))
        (<a href="#EVal_18">EVal</a> (<a href="#VNat_7">VNat</a> 1))
        (<a href="#EVal_18">EVal</a> (<a href="#VNat_7">VNat</a> 2))

  <span class="keyword">function</span> <a name="eval_bin_op_51">eval_bin_op</a> (op : <a href="#bin_op_9">bin_op</a>) (v1 v2 : <a href="#value_5">value</a>) : <a href="option.html#option_5">option</a> <a href="#value_5">value</a>
  = <span class="keyword">match</span> op, v1, v2 <span class="keyword">with</span>
  | <a href="#PlusOp_10">PlusOp</a>, <a href="#VNat_7">VNat</a> n1, <a href="#VNat_7">VNat</a> n2 -&gt; <a href="option.html#Some_5">Some</a> (<a href="#VNat_7">VNat</a> (n1 <a href="int.html#infix%20+_19">+</a> n2))
  | <a href="#MinusOp_11">MinusOp</a>, <a href="#VNat_7">VNat</a> n1, <a href="#VNat_7">VNat</a> n2 -&gt; <a href="option.html#Some_5">Some</a> (<a href="#VNat_7">VNat</a> (n1 <a href="int.html#infix%20-_23">-</a> n2))
  | <a href="#LeOp_12">LeOp</a>, <a href="#VNat_7">VNat</a> n1, <a href="#VNat_7">VNat</a> n2 -&gt; <a href="option.html#Some_5">Some</a> (<a href="#VBool_6">VBool</a> (n1 <a href="int.html#infix%20%3C=_25">&lt;=</a> n2))
  | <a href="#LtOp_13">LtOp</a>, <a href="#VNat_7">VNat</a> n1, <a href="#VNat_7">VNat</a> n2 -&gt; <a href="option.html#Some_5">Some</a> (<a href="#VBool_6">VBool</a> (n1 <a href="int.html#infix%20%3C_21">&lt;</a> n2))
  | <a href="#EqOp_14">EqOp</a>, <a href="#VNat_7">VNat</a> n1, <a href="#VNat_7">VNat</a> n2 -&gt; <a href="option.html#Some_5">Some</a> (<a href="#VBool_6">VBool</a> (n1 = n2))
  | <a href="#EqOp_14">EqOp</a>, <a href="#VBool_6">VBool</a> n1, <a href="#VBool_6">VBool</a> n2 -&gt; <a href="option.html#Some_5">Some</a> (<a href="#VBool_6">VBool</a> (n1 = n2))
  | _, _, _ -&gt; <a href="option.html#None_5">None</a>
  <span class="keyword">end</span>

  <span class="keyword">type</span> <a name="vmap_62">vmap</a> = <a href="map.html#map_9">map</a> string (<a href="option.html#option_5">option</a> <a href="#value_5">value</a>)

  <span class="keyword">function</span> <a name="subst_65">subst</a> (x : string) (w : <a href="#value_5">value</a>) (e : <a href="#expr_16">expr</a>) : <a href="#expr_16">expr</a>
  = <span class="keyword">match</span> e <span class="keyword">with</span>
    | <a href="#EVal_18">EVal</a> v -&gt; <a href="#EVal_18">EVal</a> v
    | <a href="#EVar_17">EVar</a> y -&gt; <span class="keyword">if</span> x = y <span class="keyword">then</span> <a href="#EVal_18">EVal</a> w <span class="keyword">else</span> <a href="#EVar_17">EVar</a> y
    | <a href="#ELet_19">ELet</a> y e1 e2 -&gt;
       <span class="keyword">if</span> x = y
       <span class="keyword">then</span> <a href="#ELet_19">ELet</a> y (<a href="#subst_65">subst</a> x w e1) e2
       <span class="keyword">else</span> <a href="#ELet_19">ELet</a> y (<a href="#subst_65">subst</a> x w e1) (<a href="#subst_65">subst</a> x w e2)
    | <a href="#EOp_20">EOp</a> op e1 e2 -&gt; <a href="#EOp_20">EOp</a> op (<a href="#subst_65">subst</a> x w e1) (<a href="#subst_65">subst</a> x w e2)
    | <a href="#EIf_21">EIf</a> e1 e2 e3 -&gt; <a href="#EIf_21">EIf</a> (<a href="#subst_65">subst</a> x w e1) (<a href="#subst_65">subst</a> x w e2) (<a href="#subst_65">subst</a> x w e3)
    <span class="keyword">end</span>

  <span class="keyword">let</span> <span class="keyword">rec</span> <span class="keyword">ghost</span> <span class="keyword">function</span> <a name="eval_expr_77">eval_expr</a> (expr : <a href="#expr_16">expr</a>) ( v: <a href="#vmap_62">vmap</a>) : <a href="option.html#option_5">option</a> <a href="#value_5">value</a>
    <span class="keyword">variant</span> { expr }
  = <span class="keyword">match</span> expr <span class="keyword">with</span>
    | <a href="#EVar_17">EVar</a> s -&gt; (<a href="map.html#get_11">get</a> v s)
    | <a href="#EVal_18">EVal</a> v -&gt; <a href="option.html#Some_5">Some</a> v
    | <a href="#ELet_19">ELet</a> s e1 e2 -&gt; <span class="keyword">match</span> eval_expr e1 v <span class="keyword">with</span>
                      | <a href="option.html#None_5">None</a> -&gt; <a href="option.html#None_5">None</a>
                      | <a href="option.html#Some_5">Some</a> vlue -&gt; eval_expr e2 (<a href="map.html#set_13">set</a> v s (<a href="option.html#Some_5">Some</a> vlue))
                      <span class="keyword">end</span>
    | <a href="#EOp_20">EOp</a> op e1 e2 -&gt; <span class="keyword">match</span> eval_expr e1 v <span class="keyword">with</span>
                      | <a href="option.html#None_5">None</a> -&gt; <a href="option.html#None_5">None</a>
                      | <a href="option.html#Some_5">Some</a> vlue1 -&gt; <span class="keyword">match</span> eval_expr e2 v <span class="keyword">with</span>
                                     | <a href="option.html#None_5">None</a> -&gt; <a href="option.html#None_5">None</a>
                                     | <a href="option.html#Some_5">Some</a> vlue2 -&gt; <a href="#eval_bin_op_51">eval_bin_op</a> op vlue1 vlue2
                                     <span class="keyword">end</span>
                      <span class="keyword">end</span>
    | <a href="#EIf_21">EIf</a> e1 etrue efalse -&gt; <span class="keyword">match</span> eval_expr e1 v <span class="keyword">with</span>
                              | <a href="option.html#Some_5">Some</a> (<a href="#VBool_6">VBool</a> True) -&gt; eval_expr etrue v
                              | <a href="option.html#Some_5">Some</a> (<a href="#VBool_6">VBool</a> False) -&gt; eval_expr efalse v
                              | _ -&gt; <a href="option.html#None_5">None</a>
                              <span class="keyword">end</span>
  <span class="keyword">end</span>

  <span class="keyword">meta</span> rewrite_def <span class="keyword">function</span> <a href="#eval_expr_77">eval_expr</a>

  <span class="keyword">inductive</span> <a name="big_step_102">big_step</a> <a href="#expr_16">expr</a> <a href="#value_5">value</a> =
    | <a name="Val_big_step_103">Val_big_step</a>: <span class="keyword">forall</span> v. <a href="#big_step_102">big_step</a> (<a href="#EVal_18">EVal</a> v) v
    | <a name="Let_big_step_104">Let_big_step</a>: <span class="keyword">forall</span> y e1 e2 v1 v2.
       <a href="#big_step_102">big_step</a> e1 v1 -&gt;
       <a href="#big_step_102">big_step</a> (<a href="#subst_65">subst</a> y v1 e2) v2 -&gt;
       <a href="#big_step_102">big_step</a> (<a href="#ELet_19">ELet</a> y e1 e2) v2
    | <a name="If_big_step_true_108">If_big_step_true</a>: <span class="keyword">forall</span> e1 e2 e3 v.
       <a href="#big_step_102">big_step</a> e1 (<a href="#VBool_6">VBool</a> <span class="keyword">true</span>) -&gt;
       <a href="#big_step_102">big_step</a> e2 v -&gt;
       <a href="#big_step_102">big_step</a> (<a href="#EIf_21">EIf</a> e1 e2 e3) v
    | <a name="If_big_step_false_112">If_big_step_false</a>: <span class="keyword">forall</span> e1 e2 e3 v.
       <a href="#big_step_102">big_step</a> e1 (<a href="#VBool_6">VBool</a> <span class="keyword">false</span>) -&gt;
       <a href="#big_step_102">big_step</a> e3 v -&gt;
       <a href="#big_step_102">big_step</a> (<a href="#EIf_21">EIf</a> e1 e2 e3) v
    | <a name="Op_big_step_116">Op_big_step</a>: <span class="keyword">forall</span> e1 e2 op v1 v2 v.
       <a href="#big_step_102">big_step</a> e1 v1 -&gt;
       <a href="#big_step_102">big_step</a> e2 v2 -&gt;
       <a href="#eval_bin_op_51">eval_bin_op</a> op v1 v2 = <a href="option.html#Some_5">Some</a> v -&gt;
       <a href="#big_step_102">big_step</a> (<a href="#EOp_20">EOp</a> op e1 e2) v

  <span class="keyword">goal</span> <a name="big_step_example1_123">big_step_example1</a>:
    <a href="#big_step_102">big_step</a> <a href="#example1_24">example1</a> (<a href="#VBool_6">VBool</a> <span class="keyword">true</span>)

  <span class="keyword">lemma</span> <a name="big_step_example2_126">big_step_example2</a>:
    <a href="#big_step_102">big_step</a> <a href="#example2_30">example2</a> (<a href="#VBool_6">VBool</a> <span class="keyword">true</span>)

  <span class="keyword">lemma</span> <a name="big_step_example3_129">big_step_example3</a>:
    <a href="#big_step_102">big_step</a> <a href="#example3_36">example3</a> (<a href="#VBool_6">VBool</a> <span class="keyword">false</span>)

  <span class="keyword">lemma</span> <a name="big_step_example4_132">big_step_example4</a>:
    <a href="#big_step_102">big_step</a> <a href="#example4_40">example4</a> (<a href="#VNat_7">VNat</a> 4)

  <span class="keyword">lemma</span> <a name="big_step_example5_135">big_step_example5</a>:
    <a href="#big_step_102">big_step</a> <a href="#example5_45">example5</a> (<a href="#VNat_7">VNat</a> 1)

  <span class="comment">(* ## Determinism of the big-step semantics *)</span>
  <span class="keyword">lemma</span> <a name="big_step_deterministic_139">big_step_deterministic</a>: <span class="keyword">forall</span> e v1.
    <a href="#big_step_102">big_step</a> e v1 -&gt;
     <span class="keyword">forall</span> v2. <a href="#big_step_102">big_step</a> e v2 -&gt;
      v1 = v2

  <span class="comment">(* Small-step *)</span>

  <span class="keyword">inductive</span> <a name="head_step_147">head_step</a> <a href="#expr_16">expr</a> <a href="#expr_16">expr</a> =
  | <a name="Let_headstep_148">Let_headstep</a>: <span class="keyword">forall</span> y e2 v1.
     <a href="#head_step_147">head_step</a> (<a href="#ELet_19">ELet</a> y (<a href="#EVal_18">EVal</a> v1) e2) (<a href="#subst_65">subst</a> y v1 e2)
  | <a name="If_headstep_true_150">If_headstep_true</a>: <span class="keyword">forall</span> e2 e3.
     <a href="#head_step_147">head_step</a> (<a href="#EIf_21">EIf</a> (<a href="#EVal_18">EVal</a> (<a href="#VBool_6">VBool</a> <span class="keyword">true</span>)) e2 e3) e2
  | <a name="If_headstep_false_152">If_headstep_false</a>: <span class="keyword">forall</span> e2 e3.
     <a href="#head_step_147">head_step</a> (<a href="#EIf_21">EIf</a> (<a href="#EVal_18">EVal</a> (<a href="#VBool_6">VBool</a> <span class="keyword">false</span>)) e2 e3) e3
  | <a name="Op_headstep_154">Op_headstep</a>: <span class="keyword">forall</span> op v1 v2 v.
     <a href="#eval_bin_op_51">eval_bin_op</a> op v1 v2 = <a href="option.html#Some_5">Some</a> v -&gt;
     <a href="#head_step_147">head_step</a> (<a href="#EOp_20">EOp</a> op (<a href="#EVal_18">EVal</a> v1) (<a href="#EVal_18">EVal</a> v2)) (<a href="#EVal_18">EVal</a> v)

  <span class="keyword">type</span> <a name="ctx_item_158">ctx_item</a> =
    | <a name="LetCtx_159">LetCtx</a> string <a href="#expr_16">expr</a>
    | <a name="OpCtxL_160">OpCtxL</a> <a href="#bin_op_9">bin_op</a> <a href="#expr_16">expr</a>
    | <a name="OpCtxR_161">OpCtxR</a> <a href="#bin_op_9">bin_op</a> <a href="#value_5">value</a>
    | <a name="IfCtx_162">IfCtx</a> <a href="#expr_16">expr</a> <a href="#expr_16">expr</a>

  <span class="keyword">type</span> <a name="ctx_164">ctx</a> = <a href="list.html#list_8">list</a> <a href="#ctx_item_158">ctx_item</a>

  <span class="keyword">function</span> <a name="fill_item_166">fill_item</a> (ectx: <a href="#ctx_item_158">ctx_item</a>) (e: <a href="#expr_16">expr</a>) : <a href="#expr_16">expr</a>
  = <span class="keyword">match</span> ectx <span class="keyword">with</span>
    | <a href="#LetCtx_159">LetCtx</a> s e2 -&gt; <a href="#ELet_19">ELet</a> s e e2
    | <a href="#OpCtxL_160">OpCtxL</a> op e2 -&gt; <a href="#EOp_20">EOp</a> op e e2
    | <a href="#OpCtxR_161">OpCtxR</a> op v1 -&gt; <a href="#EOp_20">EOp</a> op (<a href="#EVal_18">EVal</a> v1) e
    | <a href="#IfCtx_162">IfCtx</a> e2 e3 -&gt; <a href="#EIf_21">EIf</a> e e2 e3
    <span class="keyword">end</span>

  <span class="keyword">function</span> <a name="fill_174">fill</a> (ectx : <a href="#ctx_164">ctx</a>) (e: <a href="#expr_16">expr</a>) : <a href="#expr_16">expr</a>
  = <span class="keyword">match</span> ectx <span class="keyword">with</span>
    | <a href="list.html#Nil_8">Nil</a> -&gt; e
    | <a href="list.html#Cons_8">Cons</a> x l -&gt; <a href="#fill_item_166">fill_item</a> x (<a href="#fill_174">fill</a> l e)
    <span class="keyword">end</span>

  <span class="keyword">inductive</span> <a name="step_180">step</a> <a href="#expr_16">expr</a> <a href="#expr_16">expr</a> =
  | <a name="do_step_181">do_step</a>: <span class="keyword">forall</span> ectx e1 e2.
     <a href="#head_step_147">head_step</a> e1 e2 -&gt;
      <a href="#step_180">step</a> (<a href="#fill_174">fill</a> ectx e1) (<a href="#fill_174">fill</a> ectx e2)

  <span class="comment">(*
  Transitive/reflexive closure of the reduction relation.
  *)</span>
  <span class="keyword">inductive</span> <a name="steps_188">steps</a> <a href="#expr_16">expr</a> <a href="#expr_16">expr</a> =
    | <a name="steps_refl_189">steps_refl</a>: <span class="keyword">forall</span> e. <a href="#steps_188">steps</a> e e
    | <a name="steps_step_190">steps_step</a>: <span class="keyword">forall</span> e1 e2 e3.
       <a href="#step_180">step</a> e1 e2 -&gt;
        <a href="#steps_188">steps</a> e2 e3 -&gt;
          <a href="#steps_188">steps</a> e1 e3

  <span class="comment">(* ## Correspondence between big-step and small-step semantics *)</span>

  <span class="keyword">lemma</span> <a name="head_step_big_step_197">head_step_big_step</a>: <span class="keyword">forall</span> e1 e2 v.
    <a href="#head_step_147">head_step</a> e1 e2 -&gt;
    <a href="#big_step_102">big_step</a> e2 v -&gt;
    <a href="#big_step_102">big_step</a> e1 v

  <span class="keyword">lemma</span> <a name="big_step_fill_item_202">big_step_fill_item</a>: <span class="keyword">forall</span> ectx e v v'.
    <a href="#big_step_102">big_step</a> e v' -&gt;
    <a href="#big_step_102">big_step</a> (<a href="#fill_item_166">fill_item</a> ectx (<a href="#EVal_18">EVal</a> v')) v -&gt;
    <a href="#big_step_102">big_step</a> (<a href="#fill_item_166">fill_item</a> ectx e) v

  <span class="keyword">lemma</span> <a name="big_step_fill_item_inv_207">big_step_fill_item_inv</a>: <span class="keyword">forall</span> ectx e v.
    <a href="#big_step_102">big_step</a> (<a href="#fill_item_166">fill_item</a> ectx e) v -&gt;
    <span class="keyword">exists</span> v'. <a href="#big_step_102">big_step</a> e v' /\ <a href="#big_step_102">big_step</a> (<a href="#fill_item_166">fill_item</a> ectx (<a href="#EVal_18">EVal</a> v')) v

  <span class="keyword">lemma</span> <a name="big_step_fill_211">big_step_fill</a>: <span class="keyword">forall</span> ectx e v v'.
    <a href="#big_step_102">big_step</a> e v' -&gt;
    <a href="#big_step_102">big_step</a> (<a href="#fill_174">fill</a> ectx (<a href="#EVal_18">EVal</a> v')) v -&gt;
    <a href="#big_step_102">big_step</a> (<a href="#fill_174">fill</a> ectx e) v

  <span class="keyword">lemma</span> <a name="big_step_fill_inv_216">big_step_fill_inv</a>: <span class="keyword">forall</span> ectx e v.
    <a href="#big_step_102">big_step</a> (<a href="#fill_174">fill</a> ectx e) v -&gt;
    <span class="keyword">exists</span> v'. <a href="#big_step_102">big_step</a> e v' /\ <a href="#big_step_102">big_step</a> (<a href="#fill_174">fill</a> ectx (<a href="#EVal_18">EVal</a> v')) v

  <span class="keyword">lemma</span> <a name="head_step_step_221">head_step_step</a>: <span class="keyword">forall</span> e1 e2.
    <a href="#head_step_147">head_step</a> e1 e2 -&gt;
      <a href="#step_180">step</a> e1 e2

  <span class="keyword">lemma</span> <a name="step_steps_225">step_steps</a>: <span class="keyword">forall</span> e1 e2.
    <a href="#step_180">step</a> e1 e2 -&gt;
      <a href="#steps_188">steps</a> e1 e2

  <span class="keyword">lemma</span> <a name="step_step_steps_229">step_step_steps</a>: <span class="keyword">forall</span> e1 e2.
    <a href="#step_180">step</a> e1 e2 -&gt;
      <span class="keyword">forall</span> e3. <a href="#step_180">step</a> e2 e3 -&gt;
        <a href="#steps_188">steps</a> e1 e3

  <span class="keyword">lemma</span> <a name="head_step_steps_234">head_step_steps</a>: <span class="keyword">forall</span> e1 e2.
    <a href="#head_step_147">head_step</a> e1 e2 -&gt; <a href="#steps_188">steps</a> e1 e2

  <span class="keyword">lemma</span> <a name="step_big_step_239">step_big_step</a>: <span class="keyword">forall</span> e1 e2 v.
    <a href="#step_180">step</a> e1 e2 -&gt;
    <a href="#big_step_102">big_step</a> e2 v -&gt;
    <a href="#big_step_102">big_step</a> e1 v

  <span class="keyword">lemma</span> <a name="steps_big_step_244">steps_big_step</a>: <span class="keyword">forall</span> e1 e2 v.
    <a href="#steps_188">steps</a> e1 e2 -&gt;
    <a href="#big_step_102">big_step</a> e2 v -&gt;
    <a href="#big_step_102">big_step</a> e1 v

  <span class="keyword">lemma</span> <a name="steps_val_big_step_249">steps_val_big_step</a>: <span class="keyword">forall</span> e v.
    <a href="#steps_188">steps</a> e (<a href="#EVal_18">EVal</a> v) -&gt;
    <a href="#big_step_102">big_step</a> e v

  <span class="keyword">lemma</span> <a name="steps_trans_253">steps_trans</a>: <span class="keyword">forall</span> e1 e2 e3.
    <a href="#steps_188">steps</a> e1 e2-&gt;
    <a href="#steps_188">steps</a> e2 e3 -&gt;
    <a href="#steps_188">steps</a> e1 e3

  <span class="keyword">lemma</span> <a name="step_fill_item_258">step_fill_item</a>: <span class="keyword">forall</span> ectx e1 e2.
    <a href="#step_180">step</a> e1 e2 -&gt;
    <a href="#step_180">step</a> (<a href="#fill_item_166">fill_item</a> ectx e1) (<a href="#fill_item_166">fill_item</a> ectx e2)

  <span class="keyword">lemma</span> <a name="steps_fill_item_262">steps_fill_item</a>: <span class="keyword">forall</span> ectx e1 e2.
    <a href="#steps_188">steps</a> e1 e2 -&gt;
    <a href="#steps_188">steps</a> (<a href="#fill_item_166">fill_item</a> ectx e1) (<a href="#fill_item_166">fill_item</a> ectx e2)

  <span class="keyword">lemma</span> <a name="big_step_steps_val_266">big_step_steps_val</a>: <span class="keyword">forall</span> e v.
    <a href="#big_step_102">big_step</a> e v -&gt;
    <a href="#steps_188">steps</a> e (<a href="#EVal_18">EVal</a> v)

<span class="keyword">end</span></pre>

</div>
<hr>
<p>Generated by why3doc 1.4.0+git</p>
</body>
</html>
